Lines Matching +full:no +full:- +full:output
3 # SPDX-License-Identifier: GPL-2.0
5 set -e
12 rm -f ${perfdata}
13 rm -f ${result}
14 trap - EXIT TERM INT
24 if [ "$(id -u)" != 0 ]; then
25 echo "[Skip] No root permission"
30 if ! perf list | grep -q lock:contention_begin; then
31 echo "[Skip] No lock contention tracepoints"
37 if [ `nproc` -lt 4 ]; then
47 perf lock record -o ${perfdata} -- perf bench sched messaging > /dev/null 2>&1
48 # the output goes to the stderr and we expect only 1 output (-E 1)
49 perf lock contention -i ${perfdata} -E 1 -q 2> ${result}
50 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
51 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
59 echo "Testing perf lock contention --use-bpf"
61 if ! perf lock con -b true > /dev/null 2>&1 ; then
62 echo "[Skip] No BPF support"
66 # the perf lock contention output goes to the stderr
67 perf lock con -a -b -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
68 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
69 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
78 perf lock record -o- -- perf bench sched messaging 2> /dev/null | \
79 perf lock contention -i- -E 1 -q 2> ${result}
80 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
81 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
89 echo "Testing perf lock contention --threads"
90 perf lock contention -i ${perfdata} -t -E 1 -q 2> ${result}
91 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
92 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
97 if ! perf lock con -b true > /dev/null 2>&1 ; then
101 # the perf lock contention output goes to the stderr
102 perf lock con -a -b -t -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
103 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
104 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
112 echo "Testing perf lock contention --lock-addr"
113 perf lock contention -i ${perfdata} -l -E 1 -q 2> ${result}
114 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
115 echo "[Fail] Recorded result count is not 1:" "$(cat "${result}" | wc -l)"
120 if ! perf lock con -b true > /dev/null 2>&1 ; then
124 # the perf lock contention output goes to the stderr
125 perf lock con -a -b -l -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
126 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
127 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
135 echo "Testing perf lock contention --lock-cgroup"
137 if ! perf lock con -b true > /dev/null 2>&1 ; then
138 echo "[Skip] No BPF support"
142 # the perf lock contention output goes to the stderr
143 perf lock con -a -b -g -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
144 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
145 echo "[Fail] BPF result count is not 1:" "$(cat "${result}" | wc -l)"
153 echo "Testing perf lock contention --type-filter (w/ spinlock)"
154 perf lock contention -i ${perfdata} -Y spinlock -q 2> ${result}
155 if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
156 echo "[Fail] Recorded result should not have non-spinlocks:" "$(cat "${result}")"
161 if ! perf lock con -b true > /dev/null 2>&1 ; then
165 perf lock con -a -b -Y spinlock -q -- perf bench sched messaging > /dev/null 2> ${result}
166 if [ "$(grep -c -v spinlock "${result}")" != "0" ]; then
167 echo "[Fail] BPF result should not have non-spinlocks:" "$(cat "${result}")"
175 echo "Testing perf lock contention --lock-filter (w/ tasklist_lock)"
176 perf lock contention -i ${perfdata} -l -q 2> ${result}
177 if [ "$(grep -c tasklist_lock "${result}")" != "1" ]; then
182 perf lock contention -i ${perfdata} -L tasklist_lock -q 2> ${result}
185 test_lock_filter_type=$(head -1 "${result}" | awk '{ print $8 }' | sed -e 's/:.*//')
187 if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
188 …echo "[Fail] Recorded result should not have non-${test_lock_filter_type} locks:" "$(cat "${result…
193 if ! perf lock con -b true > /dev/null 2>&1 ; then
197 perf lock con -a -b -L tasklist_lock -q -- perf bench sched messaging > /dev/null 2> ${result}
198 if [ "$(grep -c -v "${test_lock_filter_type}" "${result}")" != "0" ]; then
199 echo "[Fail] BPF result should not have non-${test_lock_filter_type} locks:" "$(cat "${result}")"
207 echo "Testing perf lock contention --callstack-filter (w/ unix_stream)"
208 perf lock contention -i ${perfdata} -v -q 2> ${result}
209 if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
214 perf lock contention -i ${perfdata} -E 1 -S unix_stream -q 2> ${result}
215 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
221 if ! perf lock con -b true > /dev/null 2>&1 ; then
225 perf lock con -a -b -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${result}
226 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
235 echo "Testing perf lock contention --callstack-filter with task aggregation"
236 perf lock contention -i ${perfdata} -v -q 2> ${result}
237 if [ "$(grep -c unix_stream "${result}")" = "0" ]; then
242 perf lock contention -i ${perfdata} -t -E 1 -S unix_stream -q 2> ${result}
243 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
249 if ! perf lock con -b true > /dev/null 2>&1 ; then
253 …perf lock con -a -b -t -S unix_stream -E 1 -q -- perf bench sched messaging > /dev/null 2> ${resul…
254 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
262 echo "Testing perf lock contention --cgroup-filter"
264 if ! perf lock con -b true > /dev/null 2>&1 ; then
265 echo "[Skip] No BPF support"
269 perf lock con -a -b -g -E 1 -F wait_total -q -- perf bench sched messaging > /dev/null 2> ${result}
270 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
277 …perf lock con -a -b -g -E 1 -G "${cgroup}" -q -- perf bench sched messaging > /dev/null 2> ${resul…
278 if [ "$(cat "${result}" | wc -l)" != "1" ]; then
288 echo "Testing perf lock contention CSV output"
289 perf lock contention -i ${perfdata} -E 1 -x , --output ${result}
291 # it should have 5: contended, total-wait, max-wait, avg-wait, type, caller
292 header=$(grep "# output:" ${result} | tr -d -c , | wc -c)
294 echo "[Fail] Recorded result does not have enough output columns: ${header} != 5"
298 # count the number of commas in the output
299 output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
300 if [ "${header}" != "${output}" ]; then
301 echo "[Fail] Recorded result does not match the number of commas: ${header} != ${output}"
306 if ! perf lock con -b true > /dev/null 2>&1 ; then
307 echo "[Skip] No BPF support"
311 # the perf lock contention output goes to the stderr
312 perf lock con -a -b -E 1 -x , --output ${result} -- perf bench sched messaging > /dev/null 2>&1
313 output=$(grep -v "^#" ${result} | tr -d -c , | wc -c)
314 if [ "${header}" != "${output}" ]; then
315 echo "[Fail] BPF result does not match the number of commas: ${header} != ${output}"